#include <string.h>
#include <cstring.h>
#include <StrUtl.h>

string CC str( int x )
{
    return strcomma( x, 0 );
}

string CC str( long x )
{
    return strcomma( x, 0 );
}

string CC strcomma( long x, int usecomma )
{
    string s;
	int sign = 0;

	if( x < 0 )
	{
		sign = -1;
		x = -x;
	}

	if( x == 0 )
		s += '0';
	else
	{
		while( x > 0 )
		{
			s += char( x % 10 + '0' );
			x /= 10;
            if( s.length() % 4 == 3 && usecomma )
				s += ',';
		}
		if( usecomma && s[s.length()-1] == ',' )
			s.remove( s.length()-1 );
        if( usecomma && s.length() == 5 )
        {
            s(3) = s[4];
            s.remove( s.length()-1 );
        }
    }

	if( sign )
        s += '-';

    for( int i = 0; i < s.length()/2; i++ )
    {
        int j = s.length()-i-1;
        char a = s[i];
        char b = s[j];
        s(i) = b;
        s(j) = a;
	}

	return s;
}

#include <stdlib.h>
long CC val( string s )
{
    for( int i = 0; i < s.length(); i++ )
        if( s[i] == ',' ) { s.remove( i, 1 ); i--; }
	const char * sr = s.c_str();
    char * endptr;
    long x = strtol( sr, &endptr, 0 );
    if( endptr > sr )
    return x;
    else
    return 0;
}

long numround( long n, int len )
{
    if( n < 0 ) return -numround(-n,len-1);
    if( len < 1 || len > 9 ) return n;

    long lim = 1;
    for( int i = 0; i < len; i++ )
        lim *= 10;

    i = 0;
    while( n >= lim )
    {
        int lastdigit = n%10;
        n /= 10;
        if( n < lim && lastdigit >= 5 ) n++;
        i++;
    }

    while( i > 0 )
    {
        n *= 10;
        i--;
    }

    return n;
}

int CC eq( const string& a, const string& b )
{
    return ( a.length() == b.length() ) && !stricmp( a.c_str(), b.c_str() );
}

int CC eq( const string& a, const char* b )
{
    return !stricmp( a.c_str(), b );
}

int CC pos( char a, const char* b, int start )
{
    string b2( b );
    return pos( a, b2, start );
}

int CC pos( char a, const string& b, int start )
{
    int len = b.length();
    for( int i = start; i < len; i++ )
        if( b[i] == a )
            return i;
    return -1;
}

int CC pos( string a, const char* b, int start )
{
    string b2( b );
    return pos( a, b2, start );
}

int CC pos( string a, const string& b, int startpos )
{
    int start = ( a.length() - 1 ) + startpos;
    if( start < 0 ) return 0;
    char c = a[start];
    for( int i = start; i < b.length(); i++ )
    {
        void *v = memchr( (char *)(b.c_str())+i, c, b.length()-i );
        if( !v ) break;
		i = int((char *)v - (char *)b.c_str());
        if( c == b[i] )
        {
            int j, k;
            for( j = 0, k = i-start; j < start; j++,k++ )
            {
                if( a[j] != b[k] )
                    goto nomatch;
            }
            return i-start;
        }
      nomatch:
        ;
    }
    return -1;
}

#ifdef _cstring_h
int string::find( const string& s, int start ) { return pos( s, *this, start ); }
int string::contains( const char* s ) { return pos( s, *this ); }
int string::contains( const string& s ) { return pos( s, *this ); }
#endif

